module Env where

import Exception
import AbsSynt

newtype Env = Env Defs deriving(Read,Show,Eq)

emptyEnv = Env []

type Defs = [Def]

newtype Def = Def (Name,SigTerm)  deriving(Read,Show,Eq)

nameOfDef (Def (n,o)) = n

namesOfDefs :: Defs -> Names
namesOfDefs = map nameOfDef

nameOfEnv (Env defs) = namesOfDefs defs 

addDefEnv d (Env defs) = Env (d:defs)
addDefsEnv ds (Env defs) = Env (ds ++ defs)

getAllDefEnv (Env []) n = 
       errorE ("getAllDefEnv: " ++ n ++ " is not in environment")
getAllDefEnv (Env (df:dfs)) n =
   if (nameOfDef df) == n
   then return df
   else getAllDefEnv (Env dfs) n
       


lookupEnv :: Name -> Env  -> E SigTerm
lookupEnv n (Env []) = errorE ("lookupEnv: " ++ show n ++ " not found") 
lookupEnv n (Env ((Def (x,o)):defs)) =
      if n == x then return o
      else lookupEnv n (Env defs)
           
newtype Program = Program (Env,SigTerm) deriving(Read,Show,Eq)
