module ParseCom where

import Char
import Exception

import AbsSynt
import Env

import Lex
import ParserMonad
import Parser

import MonadSTE
import Subst
import Reduct

data FileCom = 
   Load String | Add Def | GetDef String |  PrintEnv
 | EvalObj SigTerm | ParseE SigTerm | Compile SigTerm 
 | Reset | Quit

readLoad :: [PosTOKEN] -> E FileCom -- we do not need the state now
readLoad = parse readLoadP

readLoadP :: Parse FileCom
readLoadP = 
 do
  cmd <- idenP 
  case cmd of
    "load"   ->  return Load `apP` fileNameP
    "add"    ->  return Add  `apP` defP
    "getdef" ->  return GetDef `apP` idenP
    "env"    ->  return PrintEnv
    "eval"   ->  return EvalObj `apP` termP
    "comp"   ->  return Compile `apP` termP
    "parse"  ->  return ParseE `apP` termP
    "reset"  ->  return Reset
    "quit"   ->  return Quit
    _ -> errorP "readLoadP, not a command"


