module State where

import Exception
import AbsSynt
import Env
import MonadSTE

-- State

type State = (Env,Int)
initSt = (emptyEnv,0) :: State

getEnvState (env,_) = env
getFreshState (_,n) = n

putEnvState env (_,n) = (env,n)
putFreshState n (env,_) = (env,n)

-- Monad Sts

type StS a = STE State a

errorStS = errorSTE
stripStS = stripSTE
updateErrorStS = updateErrorSTE
getStS = getSTE
putStS = putSTE
escapeStS = escapeSTE

-- accessor functions

selectStS :: (State -> a) -> StS a
selectStS acc =
  do
    chst <- getSTE
    return (acc chst)

getEnvStS = selectStS getEnvState

getFreshStS = selectStS getFreshState

-- updating functions

updateStS :: (a -> State -> State) -> a -> StS ()
updateStS f = updateSTE . f 
 

putEnvStS = updateStS putEnvState

putFreshStS = updateStS putFreshState

-- lookup functions

lookupEnvStS :: Name -> StS SigTerm
lookupEnvStS n = 
  do
    chst <- getSTE
    liftEtoSTE (lookupEnv n (fst chst))
 
lookUpMethodAss :: Label -> Assigns -> StS Method
lookUpMethodAss l [] = errorSTE ("lookUpMethodAss: not found" ++ show l)
lookUpMethodAss l ((l',m):lms) = 
    if l == l' then return m
    else lookUpMethodAss l lms 

getAllDefState :: State -> Name -> E Def
getAllDefState = getAllDefEnv . getEnvState

