import Char
import Exception

import AbsSynt
import Env

import Lex
import ParserMonad
import Parser

import MonadSTE
import State
import Subst
import Reduct

import NewPPrint

import ParseCom
import IO

interProb p t = do 
                  putStrLn ("Problem: "++ t)
		  loop p

analyse :: String -> State -> IO ()
analyse c st =
 if null c then loop st
 else
  elimE (readLoad (lexanal c))
        (\cm -> case cm of
                     Load s -> loadFile st s

                     Add d -> do
		                let st1 = putEnvState env1 st
				    env1 = addDefEnv d env
				    env = getEnvState st
				loop st1

                     GetDef dn -> contEIO (getAllDefState st dn)
                                          (\def -> do putStrLn (printDef def)
                                                      loop st)
                                          (interProb st)

	             EvalObj o -> printIO st (value o st)

                     PrintEnv -> printIO st (printEnv (getEnvState st))

                     Compile o -> printIO st (comp o)

                     ParseE e -> printIO st (show e)

		     Reset -> loop initSt

                     Quit -> return ()
        )

        (interProb st)


loop :: State -> IO ()
loop state 
        = do putStr ">> "
             inp <- getLine
             analyse inp state                                                

main :: IO ()
main = do {putStrLn welcmssg; loop initSt}

-- Commands

contEIO :: E a -> (a -> IO b) -> (String -> IO b) -> IO b
contEIO = elimE  

-- Auxiliar functions

value :: SigTerm -> State -> String
value sgt st = elimE (stripSTE (reduct sgt) st) printObj show

run :: String -> State -> String
run str st = elimE (parseObj str) (flip value st)  show 

comp :: SigTerm -> String
comp sgt = elimE (stripSTE (compile sgt) initSt) printObj show

-- Printing 

printIO :: State -> String -> IO ()
printIO st s = do {putStrLn s ; loop st}

-- I/O Commands 

welcmssg = "Sigma-Lambda-Arith, Version 0.0.1"

homedir = "/inco/09/usr/gustun/Implementations/Objects/EnvLCLamSig/"


safeReadFile :: String -> IO String
safeReadFile fn = 
    catch (readFile fn) (\_ -> return "not found")

readFileAndDo :: String -> State -> (String -> IO ()) -> IO () -- (mmmhhh!!!)
readFileAndDo fn st success =
  do
   ans <- safeReadFile fn
   if filenotfound ans
    then interProb st (fn ++ " " ++ ans)
    else success ans
     
filenotfound = (== "not found")


readfileIO :: State -> (State -> IO ()) -> String -> IO ()
readfileIO st stf fcts =
  elimE (readFileE st fcts)
        (\(_,st1) -> stf st1)
        (interProb st)   

readFileE st s =  
  let STE f = do ds <- liftEtoSTE (parseDefs s)
                 putEnvStS (addDefsEnv (reverse ds) (getEnvState st))
  in f st

loadFile :: State -> String -> IO ()
loadFile st fn =
   readFileAndDo fn st (readfileIO st loop)

{- For the next future??

loadFiles :: State -> String -> IO ()
loadFiles st fn = 
   readFileAndDo fn st (\fcts -> readFiles st (lines fcts))
   where readFiles st [] = loop st
         readFiles st (l:ls) = 
                 readFileAndDo l st (checkfileIO st (\st1 -> readFiles st1 ls))

printHelp :: State -> IO ()
printHelp st = 
   readFileAndDo (homedir ++ "help") st prhelp
   where prhelp fcts = do {mapM_ putStrLn (lines fcts);loop st}

-}
